set(0,'defaulttextinterpreter','latex');
set(0,'DefaultTextFontname','CMU Serif');
set(0,'DefaultAxesFontName','CMU Serif');

figure(1);scatter3(X,Y,Z,20);
xlabel('User 3');
ylabel('User 2');
zlabel('User 1');

j = 1;
jm = 1;
s = 0;
sm = 0;
for i = 0:511
    b = dec2bin(i,9);
    if (b(7)=='0')
      s(j) = i+1;
      j = j + 1;
    elseif (b(7)=='1')
      sm(jm) = i+1;
      jm = jm + 1;
    end
end


figure(2);scatter3(X(sm),Y(sm),Z(sm),2,'k', 'filled');
xlabel('User 3');
ylabel('User 2');
zlabel('User 1');
hold on;

scatter3(X(s),Y(s),Z(s),15,[0.3, 0.75, 0.93]);
scatter3(m0b0(2:end,1),m0b0(2:end,2),m0b0(2:end,3),50,[235,107,43]/255, 'filled');
scatter3(m0b0(1,1),m0b0(1,2),m0b0(1,3),60,[0.11,0.31,0.21],'filled');
legend('Not included in the DHA search', 'Included in the DHA search', 'Evaluated by the DHA', 'Solution found by the DHA');

! 1st user's 1st bit = 1
figure(3);scatter3(X(s),Y(s),Z(s),2,'k', 'filled');
xlabel('User 3');
ylabel('User 2');
zlabel('User 1');
hold on;

! 8th is the best one

scatter3(X(sm),Y(sm),Z(sm),15,[0.3, 0.75, 0.93]);
scatter3(m0b1(1:7,1),m0b1(1:7,2),m0b1(1:7,3),50,[235,107,43]/255,'filled');
scatter3(m0b1(9:end,1),m0b1(9:end,2),m0b1(9:end,3),50,[235,107,43]/255,'filled');
scatter3(m0b1(8,1),m0b1(8,2),m0b1(8,3),60,[0.11,0.31,0.21],'filled');
legend('Not included in the DHA search', 'Included in the DHA search', 'Evaluated by the DHA', 'Solution found by the DHA');

!1st user's 1st bit = 1
j = 1;
jm = 1;
s = 0;
sm = 0;
for i = 0:511
    b = dec2bin(i,9);
    if (b(8)=='0')
      s(j) = i+1;
      j = j + 1;
    elseif (b(8)=='1')
      sm(jm) = i+1;
      jm = jm + 1;
    end
end

figure(4);scatter3(X(sm),Y(sm),Z(sm),2,'k', 'filled');
xlabel('User 3');
ylabel('User 2');
zlabel('User 1');
hold on;

!8th is the best one
scatter3(X(s),Y(s),Z(s),15,[0.3, 0.75, 0.93]);
scatter3(m1b0(1:7,1),m1b0(1:7,2),m1b0(1:7,3),50,[235,107,43]/255,'filled');
scatter3(m1b0(9:end,1),m1b0(9:end,2),m1b0(9:end,3),50,[235,107,43]/255,'filled');
scatter3(m1b0(8,1),m1b0(8,2),m1b0(8,3),60,[0.11,0.31,0.21],'filled');
legend('Not included in the DHA search', 'Included in the DHA search', 'Evaluated by the DHA', 'Solution found by the DHA');

!1st user's 2nd bit
j = 1;
jm = 1;
s = 0;
sm = 0;
for i = 0:511
    b = dec2bin(i,9);
    if (b(8)=='0')
      s(j) = i+1;
      j = j + 1;
    elseif (b(8)=='1')
      sm(jm) = i+1;
      jm = jm + 1;
    end
end

figure(4);scatter3(X(sm),Y(sm),Z(sm),2,'k', 'filled');
xlabel('User 3');
ylabel('User 2');
zlabel('User 1');
hold on;

! 13rd is the best one
scatter3(X(s),Y(s),Z(s),15,[0.3, 0.75, 0.93]);
scatter3(m1b0(1:12,1),m1b0(1:12,2),m1b0(1:12,3),50,[235,107,43]/255,'filled');
scatter3(m1b0(14:end,1),m1b0(14:end,2),m1b0(14:end,3),50,[235,107,43]/255,'filled');
scatter3(m1b0(13,1),m1b0(13,2),m1b0(13,3),60,[0.11,0.31,0.21],'filled');
legend('Not included in the DHA search', 'Included in the DHA search', 'Evaluated by the DHA', 'Solution found by the DHA');

! 1st user's 3rd bit
j = 1;
jm = 1;
s = 0;
sm = 0;
for i = 0:511
    b = dec2bin(i,9);
    if (b(9)=='0')
      s(j) = i+1;
      j = j + 1;
    elseif (b(9)=='1')
      sm(jm) = i+1;
      jm = jm + 1;
    end
end

figure(5);scatter3(X(s),Y(s),Z(s),2,'k', 'filled');
xlabel('User 3');
ylabel('User 2');
zlabel('User 1');
hold on;

! 15th is the best one

scatter3(X(sm),Y(sm),Z(sm),15,[0.3, 0.75, 0.93]);
scatter3(m2b1(1:14,1),m2b1(1:14,2),m2b1(1:14,3),50,[235,107,43]/255,'filled');
scatter3(m2b1(16:end,1),m2b1(16:end,2),m2b1(16:end,3),50,[235,107,43]/255,'filled');
scatter3(m2b1(15,1),m2b1(15,2),m2b1(15,3),60,[0.11,0.31,0.21],'filled');
legend('Not included in the DHA search', 'Included in the DHA search', 'Evaluated by the DHA', 'Solution found by the DHA');

!Second user's first bit
j = 1;
jm = 1;
s = 0;
sm = 0;
for i = 0:511
    b = dec2bin(i,9);
    if (b(4)=='0')
      s(j) = i+1;
      j = j + 1;
    elseif (b(4)=='1')
      sm(jm) = i+1;
      jm = jm + 1;
    end
end

! 24 was the best

figure(6);scatter3(X(s),Y(s),Z(s),2,'k', 'filled');
xlabel('User 3');
ylabel('User 2');
zlabel('User 1');
hold on;

scatter3(X(sm),Y(sm),Z(sm),15,[0.3, 0.75, 0.93]);
scatter3(m3b1(1:23,1),m3b1(1:23,2),m3b1(1:23,3),50,[235,107,43]/255,'filled');
scatter3(m3b1(25:end,1),m3b1(25:end,2),m3b1(25:end,3),50,[235,107,43]/255,'filled');
scatter3(m3b1(24,1),m3b1(24,2),m3b1(24,3),60,[0.11,0.31,0.21],'filled');
legend('Not included in the DHA search', 'Included in the DHA search', 'Evaluated by the DHA', 'Solution found by the DHA');

!Third user's third bit
j = 1;
jm = 1;
s = 0;
sm = 0;
for i = 0:511
    b = dec2bin(i,9);
    if (b(3)=='0')
      s(j) = i+1;
      j = j + 1;
    elseif (b(3)=='1')
      sm(jm) = i+1;
      jm = jm + 1;
    end
end

figure(7);scatter3(X(s),Y(s),Z(s),2,'k', 'filled');
xlabel('User 3');
ylabel('User 2');
zlabel('User 1');
hold on;

scatter3(X(sm),Y(sm),Z(sm),15,[0.3, 0.75, 0.93]);
scatter3(m8b1(2:end,1),m8b1(2:end,2),m8b1(2:end,3),50,[235,107,43]/255,'filled');
scatter3(m8b1(1,1),m8b1(1,2),m8b1(1,3),60,[0.11,0.31,0.21],'filled');
legend('Not included in the DHA search', 'Included in the DHA search', 'Evaluated by the DHA', 'Solution found by the DHA');
